Attribute VB_Name = "Module3"
Option Explicit

Public RecSrcNames()    As String   'Vettore con i nomi dei Recording Volume Controls disponibili.
Public RecSrc           As String   'Nome del Recording Volume Control correntemente selezionato.

Private RecSrcTypes$()  ' Vettore con i tipi dei Recording Volume Controls disponibili.

Private uDeviceID   As Long                  'Indice della scheda audio correntemente usata.
Private hmixer      As Long
Private VolCtrl     As MIXERCONTROL     'master volume control
Private Volume      As Long
Private MuxCtrl     As MIXERCONTROL
Private MuxValue    As Boolean

Private isNotMUX    As Boolean

Private myLabel()   As MIXERCONTROLDETAILS_LISTTEXT
Private myBoolean() As MIXERCONTROLDETAILS_BOOLEAN

Private Const MAXPNAMELEN = 32

Private Const MIXER_LONG_NAME_CHARS = 64
Private Const MIXER_SHORT_NAME_CHARS = 16

Private Const MIXER_GETLINEINFOF_SOURCE = &H1&
Private Const MIXER_GETLINEINFOF_COMPONENTTYPE = &H3&

Private Const MIXER_GETCONTROLDETAILSF_VALUE = &H0&
Private Const MIXER_GETCONTROLDETAILSF_LISTTEXT = &H1&
Private Const MIXER_GETLINECONTROLSF_ONEBYTYPE = &H2& ' separate left-right volume control

Private Const MIXER_SETCONTROLDETAILSF_VALUE = &H0&

Private Const MIXERCONTROL_CT_CLASS_FADER = &H50000000
Private Const MIXERCONTROL_CT_CLASS_SWITCH = &H20000000
Private Const MIXERCONTROL_CT_SC_SWITCH_BOOLEAN = &H0&

Private Const MIXERCONTROL_CT_UNITS_BOOLEAN = &H10000
Private Const MIXERCONTROL_CT_UNITS_UNSIGNED = &H30000

Private Const MIXERCONTROL_CT_CLASS_CUSTOM = &H0&
Private Const MIXERCONTROL_CT_CLASS_LIST = &H70000000
Private Const MIXERCONTROL_CT_CLASS_MASK = &HF0000000
Private Const MIXERCONTROL_CT_CLASS_METER = &H10000000
Private Const MIXERCONTROL_CT_CLASS_NUMBER = &H30000000
Private Const MIXERCONTROL_CT_CLASS_SLIDER = &H40000000
Private Const MIXERCONTROL_CT_CLASS_TIME = &H60000000

Private Const MIXERCONTROL_CT_SC_LIST_MULTIPLE = &H1000000
Private Const MIXERCONTROL_CT_SC_LIST_SINGLE = &H0&
Private Const MIXERCONTROL_CT_SC_METER_POLLED = &H0&
Private Const MIXERCONTROL_CT_SC_SWITCH_BUTTON = &H1000000
Private Const MIXERCONTROL_CT_SC_TIME_MICROSECS = &H0&
Private Const MIXERCONTROL_CT_SC_TIME_MILLISECS = &H1000000

Private Const MIXERCONTROL_CT_SUBCLASS_MASK = &HF000000

Private Const MIXERCONTROL_CT_UNITS_CUSTOM = &H0&
Private Const MIXERCONTROL_CT_UNITS_DECIBELS = &H40000
Private Const MIXERCONTROL_CT_UNITS_MASK = &HFF0000
Private Const MIXERCONTROL_CT_UNITS_PERCENT = &H50000
Private Const MIXERCONTROL_CT_UNITS_SIGNED = &H20000

Private Const MIXERLINE_COMPONENTTYPE_DST_FIRST = &H0&
Private Const MIXERLINE_COMPONENTTYPE_SRC_FIRST = &H1000&
Private Const MIXERLINE_COMPONENTTYPE_SRC_ANALOG = &H1000& + 10
Private Const MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY = &H1000& + 9
Private Const MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC = &H1000& + 5
Private Const MIXERLINE_COMPONENTTYPE_SRC_DIGITAL = &H1000& + 1
Private Const MIXERLINE_COMPONENTTYPE_SRC_LAST = &H1000& + 10
Private Const MIXERLINE_COMPONENTTYPE_SRC_LINE = &H1000& + 2
Private Const MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER = &H1000& + 4
Private Const MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED = &H1000& + 0
Private Const MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT = &H1000& + 8

Private Const MIXERLINE_COMPONENTTYPE_SRC_I25InVol = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1)
Private Const MIXERLINE_COMPONENTTYPE_SRC_LINEVol = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2)
Private Const MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3)
Private Const MIXERLINE_COMPONENTTYPE_SRC_MIDIVol = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4)
Private Const MIXERLINE_COMPONENTTYPE_SRC_CDVol = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5)
Private Const MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6)
Private Const MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7)
Private Const MIXERLINE_COMPONENTTYPE_SRC_WAVEDSVol = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8)
Private Const MIXERLINE_COMPONENTTYPE_src_AUXVol = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9)

Private Const MIXERLINE_COMPONENTTYPE_DST_UNDEFINED = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 0)
Private Const MIXERLINE_COMPONENTTYPE_DST_DIGITAL = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 1)
Private Const MIXERLINE_COMPONENTTYPE_DST_LINE = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 2)
Private Const MIXERLINE_COMPONENTTYPE_DST_MONITOR = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 3)
Private Const MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 4)
Private Const MIXERLINE_COMPONENTTYPE_DST_HEADPHONES = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 5)
Private Const MIXERLINE_COMPONENTTYPE_DST_TELEPHONE = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 6)
Private Const MIXERLINE_COMPONENTTYPE_DST_WAVEIN = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 7)
Private Const MIXERLINE_COMPONENTTYPE_DST_LAST = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)
Private Const MIXERLINE_COMPONENTTYPE_DST_VOICEIN = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)

' Mixer control types
Private Const MIXERCONTROL_CONTROLTYPE_FADER = (MIXERCONTROL_CT_CLASS_FADER Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_BASS = (MIXERCONTROL_CONTROLTYPE_FADER + 2)
Private Const MIXERCONTROL_CONTROLTYPE_BOOLEAN = (MIXERCONTROL_CT_CLASS_SWITCH Or MIXERCONTROL_CT_SC_SWITCH_BOOLEAN Or MIXERCONTROL_CT_UNITS_BOOLEAN)
Private Const MIXERCONTROL_CONTROLTYPE_TREBLE = (MIXERCONTROL_CONTROLTYPE_FADER + 3)
Private Const MIXERCONTROL_CONTROLTYPE_VOLUME = (MIXERCONTROL_CONTROLTYPE_FADER + 1)
Private Const MIXERCONTROL_CONTROLTYPE_MUTE = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 2)
Private Const MIXERCONTROL_CONTROLTYPE_EQUALIZER = (MIXERCONTROL_CONTROLTYPE_FADER + 4)
Private Const MIXERCONTROL_CONTROLTYPE_LOUDNESS = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 4)
Private Const MIXERCONTROL_CONTROLTYPE_SIGNEDMETER = (MIXERCONTROL_CT_CLASS_METER Or MIXERCONTROL_CT_SC_METER_POLLED Or MIXERCONTROL_CT_UNITS_SIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_PEAKMETER = (MIXERCONTROL_CONTROLTYPE_SIGNEDMETER + 1)
Private Const MIXERCONTROL_CONTROLTYPE_BOOLEANMETER = (MIXERCONTROL_CT_CLASS_METER Or MIXERCONTROL_CT_SC_METER_POLLED Or MIXERCONTROL_CT_UNITS_BOOLEAN)
Private Const MIXERCONTROL_CONTROLTYPE_BUTTON = (MIXERCONTROL_CT_CLASS_SWITCH Or MIXERCONTROL_CT_SC_SWITCH_BUTTON Or MIXERCONTROL_CT_UNITS_BOOLEAN)
Private Const MIXERCONTROL_CONTROLTYPE_CUSTOM = (MIXERCONTROL_CT_CLASS_CUSTOM Or MIXERCONTROL_CT_UNITS_CUSTOM)
Private Const MIXERCONTROL_CONTROLTYPE_DECIBELS = (MIXERCONTROL_CT_CLASS_NUMBER Or MIXERCONTROL_CT_UNITS_DECIBELS)
Private Const MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT = (MIXERCONTROL_CT_CLASS_LIST Or MIXERCONTROL_CT_SC_LIST_MULTIPLE Or MIXERCONTROL_CT_UNITS_BOOLEAN)
Private Const MIXERCONTROL_CONTROLTYPE_MICROTIME = (MIXERCONTROL_CT_CLASS_TIME Or MIXERCONTROL_CT_SC_TIME_MICROSECS Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_MILLITIME = (MIXERCONTROL_CT_CLASS_TIME Or MIXERCONTROL_CT_SC_TIME_MILLISECS Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_MIXER = (MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1)
Private Const MIXERCONTROL_CONTROLTYPE_MONO = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 3)
Private Const MIXERCONTROL_CONTROLTYPE_SLIDER = (MIXERCONTROL_CT_CLASS_SLIDER Or MIXERCONTROL_CT_UNITS_SIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_STEREOENH = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 5)
Private Const MIXERCONTROL_CONTROLTYPE_UNSIGNED = (MIXERCONTROL_CT_CLASS_NUMBER Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER = (MIXERCONTROL_CT_CLASS_METER Or MIXERCONTROL_CT_SC_METER_POLLED Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_SINGLESELECT = (MIXERCONTROL_CT_CLASS_LIST Or MIXERCONTROL_CT_SC_LIST_SINGLE Or MIXERCONTROL_CT_UNITS_BOOLEAN)
Private Const MIXERCONTROL_CONTROLTYPE_MUX = (MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1)
Private Const MIXERCONTROL_CONTROLTYPE_PAN = (MIXERCONTROL_CONTROLTYPE_SLIDER + 1)
Private Const MIXERCONTROL_CONTROLTYPE_PERCENT = (MIXERCONTROL_CT_CLASS_NUMBER Or MIXERCONTROL_CT_UNITS_PERCENT)
Private Const MIXERCONTROL_CONTROLTYPE_QSOUNDPAN = (MIXERCONTROL_CONTROLTYPE_SLIDER + 2)
Private Const MIXERCONTROL_CONTROLTYPE_SIGNED = (MIXERCONTROL_CT_CLASS_NUMBER Or MIXERCONTROL_CT_UNITS_SIGNED)

' Mixer line flags
Private Const MIXERLINE_LINEF_ACTIVE = &H1&
Private Const MIXERLINE_LINEF_DISCONNECTED = &H8000&
Private Const MIXERLINE_LINEF_SOURCE = &H80000000

' Mixer line target types
Private Const MIXERLINE_TARGETTYPE_AUX = 5
Private Const MIXERLINE_TARGETTYPE_MIDIIN = 4
Private Const MIXERLINE_TARGETTYPE_MIDIOUT = 3
Private Const MIXERLINE_TARGETTYPE_UNDEFINED = 0
Private Const MIXERLINE_TARGETTYPE_WAVEIN = 2
Private Const MIXERLINE_TARGETTYPE_WAVEOUT = 1

' Error constants
Private Const MIXERR_INVALLINE = 1024 + 0
Private Const MIXERR_BASE = 1024
Private Const MIXERR_INVALCONTROL = 1024 + 1
Private Const MIXERR_INVALVALUE = 1024 + 2
Private Const MIXERR_LASTERROR = 1024 + 2

Private Const MMSYSERR_BASE = 0
Private Const MMSYSERR_ALLOCATED = (MMSYSERR_BASE + 4)  '  device already allocated
Private Const MMSYSERR_BADDEVICEID = (MMSYSERR_BASE + 2)  '  device ID out of range
Private Const MMSYSERR_BADERRNUM = (MMSYSERR_BASE + 9)  '  error value out of range
Private Const MMSYSERR_ERROR = (MMSYSERR_BASE + 1)  '  unspecified error
Private Const MMSYSERR_HANDLEBUSY = (MMSYSERR_BASE + 12) '  handle being used
Private Const MMSYSERR_INVALFLAG = (MMSYSERR_BASE + 10) '  invalid flag passed
Private Const MMSYSERR_INVALHANDLE = (MMSYSERR_BASE + 5)  '  device handle is invalid
Private Const MMSYSERR_INVALIDALIAS = (MMSYSERR_BASE + 13) '  "Specified alias not found in WIN.INI
Private Const MMSYSERR_INVALPARAM = (MMSYSERR_BASE + 11) '  invalid parameter passed
Private Const MMSYSERR_LASTERROR = (MMSYSERR_BASE + 13) '  last error in range
Private Const MMSYSERR_NODRIVER = (MMSYSERR_BASE + 6)  '  no device driver present
Private Const MMSYSERR_NOERROR = 0  '  no error
Private Const MMSYSERR_NOMEM = (MMSYSERR_BASE + 7)  '  memory allocation error
Private Const MMSYSERR_NOTENABLED = (MMSYSERR_BASE + 3)  '  driver failed enable
Private Const MMSYSERR_NOTSUPPORTED = (MMSYSERR_BASE + 8)  '  function isn't supported

Private Type MIXERCAPS
    wMid            As Integer                   '  manufacturer id
    wPid            As Integer                   '  product id
    vDriverVersion  As Long            '  version of the driver
    szPname         As String * MAXPNAMELEN   '  product name
    fdwSupport      As Long                '  misc. support bits
    cDestinations   As Long             '  count of destinations
End Type

' Mixer line types
Private Type Target
    dwType          As Long                 'MIXERLINE_TARGETTYPE_xxxx
    dwDeviceID      As Long                 'target device ID of device type
    wMid            As Integer              'of target device
    wPid            As Integer
    vDriverVersion  As Long
    szPname         As String * MAXPNAMELEN
End Type

Private Type MIXERLINE
    cbStruct        As Long
    dwDestination   As Long
    dwSource        As Long
    dwLineID        As Long
    fdwLine         As Long
    dwUser          As Long
    dwComponentType As Long
    cChannels       As Long
    cConnections    As Long
    cControls       As Long
    szShortName     As String * MIXER_SHORT_NAME_CHARS
    szName          As String * MIXER_LONG_NAME_CHARS
    dwType          As Long
    dwDeviceID      As Long
    wMid            As Integer
    wPid            As Integer
    vDriverVersion  As Long
    szPname         As String * MAXPNAMELEN
End Type

Private Type MIXERLINECONTROLS
    cbStruct        As Long         'size in Byte of MIXERLINECONTROLS
    dwLineID        As Long         'line id (from MIXERLINE.dwLineID)
    dwControl       As Long         'used with MIXER_GETLINECONTROLSF_ONEBYTYPE or MIXER_GETLINECONTROLSF_ONEBYID
    cControls       As Long         'count of controls pmxctrl points to
    cbmxctrl        As Long         'size in Byte of _one_ MIXERCONTROL
    pamxctrl        As Long         'pointer to first MIXERCONTROL array
End Type

Private Type MIXERCONTROL
    cbStruct        As Long         'size in Byte of MIXERCONTROL
    dwControlID     As Long         'unique control id for mixer device
    dwControlType   As Long         'MIXERCONTROL_CONTROLTYPE_xxx
    fdwControl      As Long         'MIXERCONTROL_CONTROLF_xxx
    cMultipleItems  As Long         'if MIXERCONTROL_CONTROLF_MULTIPLE set
    szShortName     As String * MIXER_SHORT_NAME_CHARS
    szName          As String * MIXER_LONG_NAME_CHARS
    Bounds(1 To 6)  As Long         'Longest member of the Bounds union
    Metrics(1 To 6) As Long         'Longest member of the Metrics union
End Type

Private Type MIXERCONTROLDETAILS
    cbStruct        As Long         'size in Byte of MIXERCONTROLDETAILS
    dwControlID     As Long         'control id to get/set details on
    cChannels       As Long         'number of channels in paDetails array
    item            As Long         'hwndOwner or cMultipleItems
    cbDetails       As Long         'size of _one_ details_XX struct
    paDetails       As Long         'pointer to array of details_XX structs
End Type

Private Type MIXERCONTROLDETAILS_BOOLEAN
     fValue         As Long
End Type

Private Type MIXERCONTROLDETAILS_LISTTEXT
    dwParam1        As Long
    dwParam2        As Long
    szName(MIXER_LONG_NAME_CHARS - 1) As Byte 'String * MIXER_LONG_NAME_CHARS
End Type

Private Type MIXERCONTROLDETAILS_SIGNED
    lValue As Long
End Type

Private Type MIXERCONTROLDETAILS_UNSIGNED
    dwValue As Long
End Type

Private Declare Function mixerClose Lib "winmm.dll" (ByVal hmx As Long) As Long
Private Declare Function mixerGetControlDetails Lib "winmm.dll" Alias "mixerGetControlDetailsA" (ByVal hmxobj As Long, pmxcd As MIXERCONTROLDETAILS, ByVal fdwDetails As Long) As Long
Private Declare Function mixerGetDevCaps Lib "winmm.dll" Alias "mixerGetDevCapsA" (ByVal uMxId As Long, pmxcaps As MIXERCAPS, ByVal cbmxcaps As Long) As Long
Private Declare Function mixerGetID Lib "winmm.dll" (ByVal hmxobj As Long, pumxID As Long, ByVal fdwId As Long) As Long
Private Declare Function mixerGetLineControls Lib "winmm.dll" Alias "mixerGetLineControlsA" (ByVal hmxobj As Long, pmxlc As MIXERLINECONTROLS, ByVal fdwControls As Long) As Long
Private Declare Function mixerGetLineInfo Lib "winmm.dll" Alias "mixerGetLineInfoA" (ByVal hmxobj As Long, pmxl As MIXERLINE, ByVal fdwInfo As Long) As Long
Private Declare Function mixerGetNumDevs Lib "winmm.dll" () As Long
Private Declare Function mixerMessage Lib "winmm.dll" (ByVal hmx As Long, ByVal uMsg As Long, ByVal dwParam1 As Long, ByVal dwParam2 As Long) As Long
Private Declare Function mixerOpen Lib "winmm.dll" (phmx As Long, ByVal uMxId As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal fdwOpen As Long) As Long
Private Declare Function mixerSetControlDetails Lib "winmm.dll" (ByVal hmxobj As Long, pmxcd As MIXERCONTROLDETAILS, ByVal fdwDetails As Long) As Long

Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, ByVal Source As Long, ByVal length As Long)

Private Declare Sub CopyStructFromPtr Lib "kernel32" Alias "RtlMoveMemory" (struct As Any, ByVal ptr As Long, ByVal cb As Long)

Private Declare Sub CopyPtrFromStruct Lib "kernel32" Alias "RtlMoveMemory" (ByVal ptr As Long, struct As Any, ByVal cb As Long)

Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long

Private Declare Function GlobalLock Lib "kernel32" (ByVal hmem As Long) As Long

Private Declare Function GlobalFree Lib "kernel32" (ByVal hmem As Long) As Long

Public Function CercaCanali(ByVal frmConOptCanali As Form) As Boolean
On Error GoTo CercaCanali_ERR
Dim i       As Long
Dim i1      As Long
Dim i2      As Long
Dim CVSet   As Long
Dim M       As Long
    uDeviceID = 0
    fGetState CVSet
    fGetText
    With frmConOptCanali
        .Frame1.Height = 12 * Screen.TwipsPerPixelY
        If (UBound(RecSrcNames) > 0) Or isNotMUX Then
            For i = 0 To UBound(RecSrcNames)
                If (i1 > .OptCanale.Count - 1) Then
                    Load .OptCanale(i1)
                    .OptCanale(i1).Top = .OptCanale(i1 - 1).Top + 24 * Screen.TwipsPerPixelY
                    .OptCanale(i1).TabIndex = .OptCanale(i1 - 1).TabIndex + 1
                End If
                .Frame1.Height = .Frame1.Height + 24 * Screen.TwipsPerPixelY
                .OptCanale(i1).Caption = "&" & i & ":  " & RecSrcNames$(i)
                .OptCanale(i1).Visible = True
                If (i = CVSet) Then
                    i2 = i1
                End If
                i1 = i1 + 1
Continua:
            Next i
            .OptCanale(i2).Value = True
        Else
            err.Raise 1001
        End If
    End With
CercaCanali_ERR:
        CercaCanali = (err = 0)
        If (err <> 0) Then
            M = "La ricerca dei canali di registrazione e' fallita." & vbNewLine & vbNewLine
            M = M & "Il sistema operativo installato su questo PC" & vbNewLine
            M = M & "potrebbe non avere le DLL richieste."
            MsgBox M, vbCritical, " CercaCanali"
        End If
End Function

'This function attempts to obtain a mixer control. Returns True if successful.
Private Function GetMixerControl(ByVal hmixer As Long, ByVal componentType As Long, ByVal ctrlType As Long, ByRef mxc As MIXERCONTROL) As Boolean
Dim mxlc    As MIXERLINECONTROLS
Dim mxl     As MIXERLINE
Dim hmem    As Long
Dim rc      As Long
    mxl.cbStruct = Len(mxl)
    mxl.dwComponentType = componentType
    'Obtain a line corresponding to the component type
    rc = mixerGetLineInfo(hmixer, mxl, MIXER_GETLINEINFOF_COMPONENTTYPE)
    If (MMSYSERR_NOERROR = rc) Then
        mxlc.cbStruct = Len(mxlc)
        mxlc.dwLineID = mxl.dwLineID
        mxlc.dwControl = ctrlType
        mxlc.cControls = 1
        mxlc.cbmxctrl = Len(mxc)
        'Allocate a buffer for the control
        hmem = GlobalAlloc(&H40, Len(mxc))
        mxlc.pamxctrl = GlobalLock(hmem)
        mxc.cbStruct = Len(mxc)
        ' Get the control
        rc = mixerGetLineControls(hmixer, mxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
        'myConnections = mxl.cConnections
        If (MMSYSERR_NOERROR = rc) Then
            GetMixerControl = True
            'Copy the control into the destination structure
            CopyStructFromPtr mxc, mxlc.pamxctrl, Len(mxc)
        Else
            GetMixerControl = False
        End If
        GlobalFree (hmem)
        Exit Function
    End If
    GetMixerControl = False
End Function

'This function Gets the value for a volume control. Returns True if successful
Private Function GetVolumeControlValue(ByVal hmixer As Long, mxc As MIXERCONTROL) As Long
Dim vol     As MIXERCONTROLDETAILS_UNSIGNED
Dim mxcd    As MIXERCONTROLDETAILS
Dim rc      As Long
Dim hmem    As Long
    mxcd.cbStruct = Len(mxcd)
    mxcd.dwControlID = mxc.dwControlID
    mxcd.cChannels = 1
    mxcd.item = mxc.cMultipleItems
    mxcd.cbDetails = Len(vol)
    mxcd.paDetails = 0
    hmem = GlobalAlloc(&H40, Len(vol))
    mxcd.paDetails = GlobalLock(hmem)
    rc = mixerGetControlDetails(hmixer, mxcd, MIXER_GETCONTROLDETAILSF_VALUE)
    CopyStructFromPtr vol, mxcd.paDetails, Len(vol)
    GlobalFree (hmem)
    If (MMSYSERR_NOERROR = rc) Then
        GetVolumeControlValue = vol.dwValue
    Else
        GetVolumeControlValue = -1
    End If
End Function

'This function Gets the STATE value for a muxX control. Returns True if successful
Private Function GetMUXControlState(ByVal hmixer As Long, mxc As MIXERCONTROL, ByRef CVSet As Long) As Boolean
Dim blnState()  As MIXERCONTROLDETAILS_BOOLEAN
Dim mxcd        As MIXERCONTROLDETAILS
Dim hmem        As Long
Dim i           As Long
Dim rc          As Long
    ReDim blnState(0 To mxc.cMultipleItems - 1) As MIXERCONTROLDETAILS_BOOLEAN
    ReDim RecSrcNames(0 To mxc.cMultipleItems - 1)
    ReDim RecSrcTypes(0 To mxc.cMultipleItems - 1)
    For i = 0 To mxc.cMultipleItems - 1
        mxcd.cbStruct = Len(mxcd)
        mxcd.dwControlID = mxc.dwControlID
        mxcd.cChannels = 1
        mxcd.item = mxc.cMultipleItems
        mxcd.cbDetails = Len(blnState(0))
        mxcd.paDetails = 0
        'hmem = GlobalAlloc(&H40, Len(blnState(0)))
        'mxcd.paDetails = GlobalLock(hmem)
        mxcd.paDetails = VarPtr(blnState(0))
        rc = mixerGetControlDetails(hmixer, mxcd, MIXER_GETCONTROLDETAILSF_VALUE)
'        If rc = 0 Then
'            MsgBox "Return value = " & rc & " NO error", , "GetMUXControlState"
'        Else
'            MsgBox "Return value = " & rc & " ERROR!!!!", , "GetMUXControlState"
'        End If
        'CopyStructFromPtr blnState(0), mxcd.paDetails, Len(blnState(0))
        'GlobalFree (hmem)
        If (MMSYSERR_NOERROR = rc) Then
            'Debug.Print "Connection " & I & " state == " & blnState(I).fValue
            If blnState(i).fValue <> 0 Then GetMUXControlState = blnState(i).fValue
            'MsgBox "seems ok"
            If blnState(i).fValue Then CVSet = i
        Else
            GetMUXControlState = False
            'MsgBox "NOT ok"
        End If
    Next i
End Function

'This function Gets the value for a mute control. Returns True if successful
Private Function GetMUXControlText(ByVal hmixer As Long, mxc As MIXERCONTROL) As Boolean
Dim strLabel()  As MIXERCONTROLDETAILS_LISTTEXT
Dim mxcd        As MIXERCONTROLDETAILS
Dim hmem        As Long
Dim i           As Long
Dim rc          As Long
    ReDim strLabel(mxc.cMultipleItems - 1) As MIXERCONTROLDETAILS_LISTTEXT
    'MsgBox "Name: " & mxc.szName
    'MsgBox "ShortName: " & mxc.szShortName
    'MsgBox "MultipleItems: " & mxc.cMultipleItems
    For i = 0 To mxc.cMultipleItems - 1
        mxcd.cbStruct = Len(mxcd)
        mxcd.dwControlID = mxc.dwControlID
        mxcd.cChannels = 1
        mxcd.item = mxc.cMultipleItems
        mxcd.cbDetails = Len(strLabel(0)) ' * mxc.cMultipleItems
        mxcd.paDetails = 0
        'hmem = GlobalAlloc(&H40, Len(strLabel(0)) * mxc.cMultipleItems)
        'mxcd.paDetails = GlobalLock(hmem)
        mxcd.paDetails = VarPtr(strLabel(0))
        'rc = mixerGetControlDetails(hmixer, mxcd, MIXER_GETCONTROLDETAILSF_VALUE)
        rc = mixerGetControlDetails(hmixer, mxcd, MIXER_GETCONTROLDETAILSF_LISTTEXT)
'        If rc = 0 Then
'            MsgBox "Return value = " & rc & " NO error"
'        Else
'            MsgBox "Return value = " & rc & " ERROR!!!!"
'        End If
        'CopyStructFromPtr strLabel(0), mxcd.paDetails, Len(strLabel(0)) * mxc.cMultipleItems
        'GlobalFree (hmem)
        If (MMSYSERR_NOERROR = rc) Then
            'For i = 0 To mxc.cMultipleItems - 1
                'Debug.Print "Connection " & I & " == " & StrConv(strLabel(I).szName, vbUnicode)
                RecSrcNames$(i) = StrConv(strLabel(i).szName, vbUnicode)
                RecSrcNames$(i) = Left$(RecSrcNames$(i), InStr(RecSrcNames$(i), Chr$(0)) - 1)
                RecSrcTypes$(i) = strLabel(i).dwParam2
                'If strLabel(i).szName <> 0 Then GetMUXControlText = strLabel(i).szName
            'Next i
            'MsgBox "seems ok"
        Else
            GetMUXControlText = False
            'MsgBox "NOT ok"
        End If
    'Debug.Print mxc.cMultipleItems
    Next i
End Function

Private Sub fSetState(ByVal CVSet As Long)
Dim OK As Boolean
Dim rc As Long
    'Open the mixer with uDeviceID
    rc = mixerOpen(hmixer, uDeviceID, 0, 0, 0)
    If MMSYSERR_NOERROR = rc Then
        'MsgBox "Mixer opened successfully."
    Else
        'MsgBox "Couldn't open the mixer."
        Exit Sub
    End If
    'MASTER volume
    OK = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_WAVEIN, MIXERCONTROL_CONTROLTYPE_VOLUME, VolCtrl)
    If OK = True Then
        'MsgBox "Master Volume is Volume Type control"
        Volume = GetVolumeControlValue(hmixer, VolCtrl)
        'MsgBox volume
    Else
        'MsgBox "Master Volume is Not Volume Type control"
    End If
    'MASTER mux 3
    OK = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_WAVEIN, MIXERCONTROL_CONTROLTYPE_MUX, MuxCtrl)
    If OK = True Then
        'MsgBox "Master Volume is MUX Type Control"
        MuxValue = SetMUXControlState(hmixer, MuxCtrl, CVSet)
        'MsgBox "ANSWER" & muxvalue
    Else
        'MsgBox "Master Volume is Not MUX Type control"
        'TEMPORARY ONLY!
        MuxValue = GetMUXControlState(hmixer, MuxCtrl, CVSet)
    End If
    'Close the mixer
    rc = mixerClose(hmixer)
'    If MMSYSERR_NOERROR = rc Then
'        MsgBox "Mixer closed successfully."
'    Else
'        MsgBox "Couldn't close the mixer."
'    End If
End Sub

' This function Sets the value for a mux control. Returns True if successful
Private Function SetMUXControlState(ByVal hmixer As Long, mxc As MIXERCONTROL, ByVal CVSet As Long) As Boolean
Dim blnState()  As MIXERCONTROLDETAILS_BOOLEAN
Dim mxcd        As MIXERCONTROLDETAILS
Dim hmem        As Long
Dim i           As Long
Dim rc          As Long
    ReDim blnState(0 To mxc.cMultipleItems - 1) As MIXERCONTROLDETAILS_BOOLEAN
    mxcd.cbStruct = Len(mxcd)
    mxcd.dwControlID = mxc.dwControlID
    mxcd.cChannels = 1
    mxcd.item = mxc.cMultipleItems
    mxcd.cbDetails = Len(blnState(0))
    mxcd.paDetails = 0
    'hmem = GlobalAlloc(&H40, Len(blnState(0)))
    'mxcd.paDetails = GlobalLock(hmem)
    mxcd.paDetails = VarPtr(blnState(0)) 'NEW
    'set ALL connections?
    For i = 0 To mxc.cMultipleItems - 1
        If i <> CVSet Then
            blnState(i).fValue = 0
        Else
            blnState(i).fValue = 1
        End If
        'mxcd.paDetails = GlobalLock(hmem)
        'CopyPtrFromStruct mxcd.paDetails, blnState(0), Len(blnState(0)) ' * mxc.cMultipleItems
        rc = mixerSetControlDetails(hmixer, mxcd, MIXER_SETCONTROLDETAILSF_VALUE)
'        If rc = 0 Then
'            MsgBox "Return value = " & rc & " NO error"
'        Else
'            MsgBox "Return value = " & rc & " ERROR!!!!"
'        End If
    Next i
    'GlobalFree (hmem)
    If (MMSYSERR_NOERROR = rc) Then
        '''Debug.Print "Connection " & i & " state = " & blnState(i).fValue
        'If blnState(i).fValue <> 0 Then SetMUXControlState = blnState(i).fValue
        '''SetMUXControlState = blnState(i).fValue
        'MsgBox "seems ok"
    Else
        SetMUXControlState = False
        'MsgBox "NOT ok"
    End If
End Function

Private Sub fGetState(ByRef CVSet As Long)
Dim OK As Boolean
Dim rc As Long
    'Open the mixer with uDeviceID
    rc = mixerOpen(hmixer, uDeviceID, 0, 0, 0)
    If MMSYSERR_NOERROR = rc Then
        'MsgBox "Mixer opened successfully."
    Else
        'MsgBox "Couldn't open the mixer."
        Exit Sub
    End If
    'MASTER volume
    OK = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_WAVEIN, MIXERCONTROL_CONTROLTYPE_VOLUME, VolCtrl)
    If OK = True Then
        'MsgBox "Master Volume is Volume Type control", , "fGetState"
        Volume = GetVolumeControlValue(hmixer, VolCtrl)
        'MsgBox volume
    Else
        'MsgBox "Master Volume is Not Volume Type control", , "fGetState"
    End If
    'MASTER mux 3
    OK = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_WAVEIN, MIXERCONTROL_CONTROLTYPE_MUX, MuxCtrl)
    If OK = True Then
        'MsgBox "Master Volume is MUX Type Control", , "fGetState"
        MuxValue = GetMUXControlState(hmixer, MuxCtrl, CVSet)
        'MsgBox "ANSWER" & muxvalue
        isNotMUX = False
    Else
        'MsgBox "Master Volume is Not MUX Type control", , "fGetState"
        'TEMPORARY ONLY!
        MuxCtrl.cMultipleItems = 1
        MuxValue = GetMUXControlState(hmixer, MuxCtrl, CVSet)
        isNotMUX = True
    End If
    'Close the mixer
    rc = mixerClose(hmixer)
'    If MMSYSERR_NOERROR = rc Then
'        MsgBox "Mixer closed successfully."
'    Else
'        MsgBox "Couldn't close the mixer."
'    End If
End Sub

Private Sub fGetText()
Dim OK As Boolean
Dim rc As Long
    'Open the mixer with uDeviceID
    rc = mixerOpen(hmixer, uDeviceID, 0, 0, 0)
    If MMSYSERR_NOERROR = rc Then
        'MsgBox "Mixer opened successfully."
    Else
        'MsgBox "Couldn't open the mixer."
        Exit Sub
    End If
    'MASTER volume
    OK = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_WAVEIN, MIXERCONTROL_CONTROLTYPE_VOLUME, VolCtrl)
    If OK = True Then
        'MsgBox "Master Volume is Volume Type control", , "fGetState"
        Volume = GetVolumeControlValue(hmixer, VolCtrl)
        'MsgBox volume
    Else
        'MsgBox "Master Volume is Not Volume Type control", , "fGetState"
    End If
    'MASTER mux 3
    OK = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_WAVEIN, MIXERCONTROL_CONTROLTYPE_MUX, MuxCtrl)
    If OK = True Then
        'MsgBox "Master Volume is MUX Type Control", , "fGetState"
        MuxValue = GetMUXControlText(hmixer, MuxCtrl)
        'MsgBox "ANSWER" & muxvalue
        isNotMUX = False
    Else
        'MsgBox "Master Volume is Not MUX Type control", , "fGetState"
        MuxCtrl.cMultipleItems = 1
        'TEMPORARY ONLY!
        MuxValue = GetMUXControlText(hmixer, MuxCtrl)
        isNotMUX = True
    End If
    'Close the mixer
    rc = mixerClose(hmixer)
'    If MMSYSERR_NOERROR = rc Then
'        MsgBox "Mixer closed successfully."
'    Else
'        MsgBox "Couldn't close the mixer."
'    End If
End Sub

'Rende attivo il canale di ingresso a nome RecSrcName$
Public Sub ImpostaRecSource(ByVal RecSrcName As String)
Dim i   As Long
    For i = 0 To UBound(RecSrcNames)
        If (RecSrcName = RecSrcNames(i)) Then
            fSetState i
            RecSrc = RecSrcNames(i)
            Exit For
        End If
    Next i
End Sub
