Attribute VB_Name = "Module1"
Option Explicit

Global h(40) As Double

Global wFormat As WAVEFORMAT
Global wHdr(10) As WAVEHDR
Global hWaveIn As Long

Global Const WAVE_FORMAT_PCM = 1
Global Const WAVE_FORMAT_QUERY = &H1
Global Const WAVE_ALLOWSYNC = &H2

Global Const MAXPNAMELEN = 32           '  max product name length (including NULL)
Global Const MAXERRORLENGTH = 128       '  max error text length (including NULL)

'funzioni per l'input WAVE
Public Declare Function waveInAddBuffer Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveInOpen Lib "winmm.dll" (lphWaveIn As Long, ByVal uDeviceID As Long, lpFormat As WAVEFORMAT, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Public Declare Function waveInClose Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
Public Declare Function waveInPrepareHeader Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveInUnprepareHeader Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveInReset Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
Public Declare Function waveInStart Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
Public Declare Function waveInStop Lib "winmm.dll" (ByVal hWaveIn As Long) As Long

Public Type WAVEFORMAT
    wFormatTag      As Integer
    nChannels       As Integer
    nSamplesPerSec  As Long
    nAvgBytesPerSec As Long
    nBlockAlign     As Integer
    nBitsPerSample  As Integer
End Type

Public Type WAVEHDR
    lpData          As Long
    dwBufferLength  As Long
    dwBytesRecorded As Long
    dwUser          As Long
    dwFlags         As Long
    dwLoops         As Long
    lpNext          As Long
    Reserved        As Long
End Type

'Funzioni di memoria
Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Declare Function GlobalFree Lib "kernel32" (ByVal hmem As Long) As Long

Public Const GMEM_FIXED = &H0
Public Const GMEM_MOVEABLE = &H2
Public Const GMEM_NOCOMPACT = &H10
Public Const GMEM_NODISCARD = &H20
Public Const GMEM_ZEROINIT = &H40
Public Const GMEM_MODIFY = &H80
Public Const GMEM_DISCARDABLE = &H100
Public Const GMEM_NOT_BANKED = &H1000
Public Const GMEM_SHARE = &H2000
Public Const GMEM_DDESHARE = &H2000
Public Const GMEM_NOTIFY = &H4000
Public Const GMEM_LOWER = GMEM_NOT_BANKED
Public Const GMEM_VALID_FLAGS = &H7F72
Public Const GMEM_INVALID_HANDLE = &H8000

Public Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)
Public Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)

'Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE)
Public Const GMEM_DISCARDED = &H4000
Public Const GMEM_LOCKCOUNT = &HFF

Global Const WHDR_DONE = &H1                'done bit
Global Const WHDR_PREPARED = &H2            'set if this header has been prepared
Global Const WHDR_BEGINLOOP = &H4           'loop start block
Global Const WHDR_ENDLOOP = &H8             'loop end block
Global Const WHDR_INQUEUE = &H10            'reserved for driver

'Funzioni di lettura/scrittura memoria (non tutte usate ma utili)
Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal DestPointer As Long, ByVal SrcPointer As Long, ByVal nBytes As Long)
Declare Sub MemToArray Lib "kernel32" Alias "RtlMoveMemory" (DestArray As Any, ByVal SrcPointer As Long, ByVal nBytes As Long)
Declare Sub ArrayToMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal DestPointer As Long, SrcArray As Any, ByVal nBytes As Long)
Declare Sub MemToString Lib "kernel32" Alias "RtlMoveMemory" (ByVal DestString As String, ByVal SrcPointer As Long, ByVal nBytes As Long)
Declare Sub StringToMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal DestPointer As Long, ByVal SrcString As String, ByVal nBytes As Long)


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal numBytes As Long)
